Index: trunk/src/python/PyRpUnits.cc
===================================================================
--- trunk/src/python/PyRpUnits.cc	(revision 84)
+++ trunk/src/python/PyRpUnits.cc	(revision 97)
@@ -38,5 +38,5 @@
     PyObject* rv = NULL;
 
-    if (self->rp_unit){ 
+    if (self->rp_unit){
         rv = PyString_FromString(self->rp_unit->getUnitsName().c_str());
     }
@@ -50,5 +50,5 @@
     PyObject* rv = NULL;
 
-    if (self->rp_unit){ 
+    if (self->rp_unit){
         rv = PyFloat_FromDouble(self->rp_unit->getExponent());
     }
@@ -102,5 +102,5 @@
     {"makeBasis", (PyCFunction)RpUnitsObject_makeBasis, METH_VARARGS,
      "return the basis value of the value provided" },
-    
+
     {NULL}  /* Sentinel */
 };
@@ -183,5 +183,5 @@
         /*
          * need to make it so user can give any number of variables in arglist
-         * because the new argList is sent to the python conversion fxn where it 
+         * because the new argList is sent to the python conversion fxn where it
          * will be parsed in python when c++ calls the conv fxn.
         PyArg_ParseTuple(args, "O!", &RpUnitsObjectType, &toUnits);
@@ -204,7 +204,7 @@
 
     if (self->rp_unit){ 
-        outVal = (PyObject*) self->rp_unit->convert(toUnits->rp_unit, 
-                                                    // (void*)&inVal, 
-                                                    (void*)argList, 
+        outVal = (PyObject*) self->rp_unit->convert(toUnits->rp_unit,
+                                                    // (void*)&inVal,
+                                                    (void*)argList,
                                                     &result );
         if (result) {
@@ -266,5 +266,5 @@
 {
     PyObject* retVal = NULL;
-    
+
     if ((PyObject*)fxnPtr != NULL) {
         retVal = PyObject_CallObject((PyObject*)fxnPtr,(PyObject*)args);
@@ -294,6 +294,6 @@
 
     if (PyTuple_Size(args) > 0) {
-        PyArg_ParseTuple(args, "O!O!O!O!",&RpUnitsObjectType, &fromUnit, 
-                                          &RpUnitsObjectType, &toUnit, 
+        PyArg_ParseTuple(args, "O!O!O!O!",&RpUnitsObjectType, &fromUnit,
+                                          &RpUnitsObjectType, &toUnit,
                                           &PyFunction_Type, &forwConvFxnStr,
                                           &PyFunction_Type, &backConvFxnStr);
@@ -319,5 +319,5 @@
 
     // make sure we get callable functions and non-null RpUnit Objects
-    if ( PyCallable_Check(forwConvFxnStr) && 
+    if ( PyCallable_Check(forwConvFxnStr) &&
          PyCallable_Check(backConvFxnStr) &&
          fromUnit->rp_unit &&
@@ -350,5 +350,5 @@
 }
 
-PyDoc_STRVAR(RpUnits_find_doc, 
+PyDoc_STRVAR(RpUnits_find_doc,
 "find(name) -> RpUnitsObject \n\
 \n\
@@ -370,5 +370,5 @@
         return NULL;
     }
-    
+
     foundUnits = RpUnits::find(searchUnits);
 
@@ -378,10 +378,10 @@
         if (returnUnits == NULL)
             return NULL;
-        
+
         returnUnits->rp_unit = foundUnits;
     }
 
     return (PyObject*) returnUnits;
-    
+
 }
 
@@ -404,5 +404,5 @@
         return NULL;
     }
-    
+
     if (units->rp_unit) {
         result = RpUnits::makeMetric(units->rp_unit);
@@ -412,5 +412,5 @@
 }
 
-PyDoc_STRVAR(RpUnits_convert_doc, 
+PyDoc_STRVAR(RpUnits_convert_doc,
 "convert (fromVal, to, units) -> PyString \n\
 \n\
@@ -439,5 +439,5 @@
 
     static char *kwlist[] = {"fromVal", "to", "units", NULL};
-    
+
     if (PyTuple_Size(args) > 0) {
         // PyArg_ParseTuple(args, "ss|s", &fromVal, &to, &units);
@@ -467,15 +467,15 @@
     if ( (!retStr.empty()) && (result == 0) ) {
         if (unitsVal) {
-            retVal = PyString_FromString(retStr.c_str());   
+            retVal = PyString_FromString(retStr.c_str());
         }
         else {
-            // convert to a double and return that if 
+            // convert to a double and return that if
             // the units were turned off
-	    tmpPyStr = PyString_FromString(retStr.c_str());
-	    if (tmpPyStr) {
-                Py_INCREF(tmpPyStr);
-                retVal = PyFloat_FromString(tmpPyStr,NULL);
-                Py_DECREF(tmpPyStr);
-	    }
+            tmpPyStr = PyString_FromString(retStr.c_str());
+            if (tmpPyStr) {
+                    Py_INCREF(tmpPyStr);
+                    retVal = PyFloat_FromString(tmpPyStr,NULL);
+                    Py_DECREF(tmpPyStr);
+            }
         }
     }
@@ -483,5 +483,5 @@
         //keeping this around in case you want string returned instead of None
         //if (fromVal) {
-        //    retVal = PyString_FromString(fromVal);   
+        //    retVal = PyString_FromString(fromVal);
         //}
         //else {
@@ -490,5 +490,5 @@
         //}
     }
-    
+
     return retVal;
 }
@@ -506,5 +506,5 @@
     {"defineConv", RpUnits_defineConv, METH_VARARGS,
         RpUnits_defineConv_doc},
-    
+
     {"find", RpUnits_find, METH_VARARGS,
         RpUnits_find_doc},
@@ -512,8 +512,8 @@
     {"makeMetric", RpUnits_makeMetric, METH_VARARGS,
         RpUnits_makeMetric_doc},
-    
+
     {"convert", (PyCFunction)RpUnits_convert, METH_VARARGS|METH_KEYWORDS,
         RpUnits_convert_doc},
-    
+
     {NULL,        NULL}        /* sentinel */
 };
@@ -529,5 +529,5 @@
 
     /* Finalize the type object including setting type of the new type
-     * object; doing it here is required for portability to Windows 
+     * object; doing it here is required for portability to Windows
      * without requiring C++. */
     if (PyType_Ready(&RpUnitsObjectType) < 0)