Index: trunk/examples/zoo/boolean/boolean.tcl
===================================================================
--- trunk/examples/zoo/boolean/boolean.tcl	(revision 112)
+++ trunk/examples/zoo/boolean/boolean.tcl	(revision 115)
@@ -3,6 +3,8 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2005
-#  Purdue Research Foundation, West Lafayette, IN
+#  Copyright (c) 2004-2005  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # ======================================================================
 package require Rappture
Index: trunk/examples/zoo/choice/choice.tcl
===================================================================
--- trunk/examples/zoo/choice/choice.tcl	(revision 112)
+++ trunk/examples/zoo/choice/choice.tcl	(revision 115)
@@ -3,6 +3,8 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2005
-#  Purdue Research Foundation, West Lafayette, IN
+#  Copyright (c) 2004-2005  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # ======================================================================
 package require Rappture
Index: trunk/examples/zoo/cloud/cloud.tcl
===================================================================
--- trunk/examples/zoo/cloud/cloud.tcl	(revision 112)
+++ trunk/examples/zoo/cloud/cloud.tcl	(revision 115)
@@ -3,6 +3,8 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2005
-#  Purdue Research Foundation, West Lafayette, IN
+#  Copyright (c) 2004-2005  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # ======================================================================
 package require Rappture
Index: trunk/examples/zoo/curve/curve.tcl
===================================================================
--- trunk/examples/zoo/curve/curve.tcl	(revision 112)
+++ trunk/examples/zoo/curve/curve.tcl	(revision 115)
@@ -1,8 +1,10 @@
 # ----------------------------------------------------------------------
-#  EXAMPLE: Rappture <boolean> elements
+#  EXAMPLE: Rappture <curve> elements
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2005
-#  Purdue Research Foundation, West Lafayette, IN
+#  Copyright (c) 2004-2005  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # ======================================================================
 package require Rappture
Index: trunk/examples/zoo/field/field.tcl
===================================================================
--- trunk/examples/zoo/field/field.tcl	(revision 112)
+++ trunk/examples/zoo/field/field.tcl	(revision 115)
@@ -3,6 +3,8 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2005
-#  Purdue Research Foundation, West Lafayette, IN
+#  Copyright (c) 2004-2005  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # ======================================================================
 package require Rappture
Index: trunk/examples/zoo/group/group.tcl
===================================================================
--- trunk/examples/zoo/group/group.tcl	(revision 112)
+++ trunk/examples/zoo/group/group.tcl	(revision 115)
@@ -1,8 +1,10 @@
 # ----------------------------------------------------------------------
-#  EXAMPLE: Rappture <log> elements
+#  EXAMPLE: Rappture <group> elements
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2005
-#  Purdue Research Foundation, West Lafayette, IN
+#  Copyright (c) 2004-2005  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # ======================================================================
 package require Rappture
Index: trunk/examples/zoo/integer/integer.tcl
===================================================================
--- trunk/examples/zoo/integer/integer.tcl	(revision 112)
+++ trunk/examples/zoo/integer/integer.tcl	(revision 115)
@@ -3,6 +3,8 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2005
-#  Purdue Research Foundation, West Lafayette, IN
+#  Copyright (c) 2004-2005  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # ======================================================================
 package require Rappture
Index: trunk/examples/zoo/loader/loader.tcl
===================================================================
--- trunk/examples/zoo/loader/loader.tcl	(revision 112)
+++ trunk/examples/zoo/loader/loader.tcl	(revision 115)
@@ -1,8 +1,10 @@
 # ----------------------------------------------------------------------
-#  EXAMPLE: Rappture <string> elements
+#  EXAMPLE: Rappture <loader> elements
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2005
-#  Purdue Research Foundation, West Lafayette, IN
+#  Copyright (c) 2004-2005  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # ======================================================================
 package require Rappture
Index: trunk/examples/zoo/log/log.tcl
===================================================================
--- trunk/examples/zoo/log/log.tcl	(revision 112)
+++ trunk/examples/zoo/log/log.tcl	(revision 115)
@@ -3,6 +3,8 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2005
-#  Purdue Research Foundation, West Lafayette, IN
+#  Copyright (c) 2004-2005  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # ======================================================================
 package require Rappture
Index: trunk/examples/zoo/number/number.tcl
===================================================================
--- trunk/examples/zoo/number/number.tcl	(revision 112)
+++ trunk/examples/zoo/number/number.tcl	(revision 115)
@@ -3,6 +3,8 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2005
-#  Purdue Research Foundation, West Lafayette, IN
+#  Copyright (c) 2004-2005  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # ======================================================================
 package require Rappture
Index: trunk/examples/zoo/phase/phase.tcl
===================================================================
--- trunk/examples/zoo/phase/phase.tcl	(revision 112)
+++ trunk/examples/zoo/phase/phase.tcl	(revision 115)
@@ -1,8 +1,10 @@
 # ----------------------------------------------------------------------
-#  EXAMPLE: Rappture <string> elements
+#  EXAMPLE: Rappture <phase> elements
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2005
-#  Purdue Research Foundation, West Lafayette, IN
+#  Copyright (c) 2004-2005  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # ======================================================================
 package require Rappture
Index: trunk/examples/zoo/string/string.tcl
===================================================================
--- trunk/examples/zoo/string/string.tcl	(revision 112)
+++ trunk/examples/zoo/string/string.tcl	(revision 115)
@@ -3,6 +3,8 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2005
-#  Purdue Research Foundation, West Lafayette, IN
+#  Copyright (c) 2004-2005  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # ======================================================================
 package require Rappture
Index: trunk/examples/zoo/structure/structure.tcl
===================================================================
--- trunk/examples/zoo/structure/structure.tcl	(revision 112)
+++ trunk/examples/zoo/structure/structure.tcl	(revision 115)
@@ -1,8 +1,10 @@
 # ----------------------------------------------------------------------
-#  EXAMPLE: Rappture <string> elements
+#  EXAMPLE: Rappture <structure> elements
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2005
-#  Purdue Research Foundation, West Lafayette, IN
+#  Copyright (c) 2004-2005  Purdue Research Foundation
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # ======================================================================
 package require Rappture