Index: trunk/src/tcl/configure.in
===================================================================
--- trunk/src/tcl/configure.in	(revision 528)
+++ trunk/src/tcl/configure.in	(revision 530)
@@ -38,9 +38,9 @@
   blt_source_dir=$withval)
 
-AC_ARG_WITH(rappture, [  --with-rappture=DIR          Find include/rappture.h in DIR],
-  rappture_dir=$withval)
-
-AC_ARG_WITH(altpath, [  --with-altpath=DIR          Alternate path to search for required packages],
-  alt_dir=$withval)
+# AC_ARG_WITH(rappture, [  --with-rappture=DIR          Find include/rappture.h in DIR],
+#   rappture_dir=$withval)
+
+# AC_ARG_WITH(altpath, [  --with-altpath=DIR          Alternate path to search for required packages],
+#   alt_dir=$withval)
 
 #--------------------------------------------------------------------
@@ -264,53 +264,54 @@
 # for it in the --with-rappture directory.
 #--------------------------------------------------------------------
-AC_MSG_CHECKING([for rappture.h])
-RAPPTURE_DIR=""
-if test "x$rappture_dir" != "x" ; then
-  #
-  # Verify that a rappture.h file exists in the directory specified
-  # by --with-rappture.
-  #
-  if test -r "$rappture_dir/include/rappture.h" ; then
-    RAPPTURE_DIR="$rappture_dir"
-  fi
-else
-  #
-  # Otherwise, search for the rappture.h include file...
-  # 1. Search previously named locations.
-  #
-  for dir in \
-   $prefix \
-   $exec_prefix
-  do
-    if test -r "$dir/include/rappture.h" ; then
-      RAPPTURE_DIR="$dir"
-      break
-    fi
-  done
-  #
-  #  2. Search source directories.
-  #
-  if test "x$RAPPTURE_DIR" = "x" ; then
-    for dir in \
-     `ls -dr ../rappture 2>/dev/null` \
-     `ls -dr ../../rappture 2>/dev/null` \
-     `ls -dr ../../../rappture 2>/dev/null` \
-     `ls -dr C\:/opt/rappture 2>/dev/null` \
-     `ls -dr /opt/rappture 2>/dev/null` 
-    do
-      if test -r "$dir/include/rappture.h" ; then
-        RAPPTURE_DIR="$dir"
-        break
-      fi
-    done
-  fi
-fi
-AC_MSG_RESULT([${RAPPTURE_DIR}])
-
-if test "x$RAPPTURE_DIR" = "x" ; then
-  echo "can't find RAPPTURE include file \"rappture.h\""
-  echo "use --with-rappture=DIR to specify the location of rappture"
-  exit 1
-fi
+RAPPTURE_DIR=$prefix
+# AC_MSG_CHECKING([for rappture.h])
+# RAPPTURE_DIR=""
+# if test "x$rappture_dir" != "x" ; then
+#   #
+#   # Verify that a rappture.h file exists in the directory specified
+#   # by --with-rappture.
+#   #
+#   if test -r "$rappture_dir/include/rappture.h" ; then
+#     RAPPTURE_DIR="$rappture_dir"
+#   fi
+# else
+#   #
+#   # Otherwise, search for the rappture.h include file...
+#   # 1. Search previously named locations.
+#   #
+#   for dir in \
+#    $prefix \
+#    $exec_prefix
+#   do
+#     if test -r "$dir/include/rappture.h" ; then
+#       RAPPTURE_DIR="$dir"
+#       break
+#     fi
+#   done
+#   #
+#   #  2. Search source directories.
+#   #
+#   if test "x$RAPPTURE_DIR" = "x" ; then
+#     for dir in \
+#      `ls -dr ../rappture 2>/dev/null` \
+#      `ls -dr ../../rappture 2>/dev/null` \
+#      `ls -dr ../../../rappture 2>/dev/null` \
+#      `ls -dr C\:/opt/rappture 2>/dev/null` \
+#      `ls -dr /opt/rappture 2>/dev/null` 
+#     do
+#       if test -r "$dir/include/rappture.h" ; then
+#         RAPPTURE_DIR="$dir"
+#         break
+#       fi
+#     done
+#   fi
+# fi
+# AC_MSG_RESULT([${RAPPTURE_DIR}])
+# 
+# if test "x$RAPPTURE_DIR" = "x" ; then
+#   echo "can't find RAPPTURE include file \"rappture.h\""
+#   echo "use --with-rappture=DIR to specify the location of rappture"
+#   exit 1
+# fi
 
 AC_SUBST(RAPPTURE_DIR)
@@ -320,32 +321,32 @@
 # for it in the --with-scew directory.
 #--------------------------------------------------------------------
-AC_MSG_CHECKING([for alternate paths])
-ALT_DIR=""
-if test "x$alt_dir" != "x" ; then
-  #
-  # Verify that a include and lib directories exist in the directory specified
-  # by --with-altpath.
-  #
-  if test -d "$alt_dir/include" -a -d "$alt_dir/lib" ; then
-    ALT_DIR="$rappture_dir"
-  fi
-else
-  if test "x$ALT_DIR" = "x" ; then
-    for dir in \
-     C\:/opt /opt
-    do
-      if test -r "$dir/include" -a -d "$dir/lib" ; then
-        ALT_DIR="$dir"
-        break
-      fi
-    done
-  fi
-fi
-if test "x$ALT_DIR" = "x" ; then
-    AC_MSG_RESULT(none)
-  else
-    AC_MSG_RESULT([${ALT_DIR}])
-fi
-
+# AC_MSG_CHECKING([for alternate paths])
+# ALT_DIR=""
+# if test "x$alt_dir" != "x" ; then
+#   #
+#   # Verify that a include and lib directories exist in the directory specified
+#   # by --with-altpath.
+#   #
+#   if test -d "$alt_dir/include" -a -d "$alt_dir/lib" ; then
+#     ALT_DIR="$rappture_dir"
+#   fi
+# else
+#   if test "x$ALT_DIR" = "x" ; then
+#     for dir in \
+#      C\:/opt /opt
+#     do
+#       if test -r "$dir/include" -a -d "$dir/lib" ; then
+#         ALT_DIR="$dir"
+#         break
+#       fi
+#     done
+#   fi
+# fi
+# if test "x$ALT_DIR" = "x" ; then
+#     AC_MSG_RESULT(none)
+#   else
+#     AC_MSG_RESULT([${ALT_DIR}])
+# fi
+# 
 AC_SUBST(ALT_DIR)
 